import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class CircularDaySelector extends StatefulWidget {

  Color color = Colors.white;
  Color selectedColor = Colors.blue;
  Color textColor = Colors.black;
  Color selectedTextColor = Colors.white;
  double fontSize = 16;

  String dayName = "";
  bool isChecked = false;
  String code = "mon";
  bool isMonthly = false;
  bool canBeNotCircle = false;

  CircularDaySelector({
    this.dayName,
    this.isChecked,
    this.code,
    this.isMonthly,
    this.canBeNotCircle,
    this.fontSize,
    this.selectedColor,
    this.color,
    this.textColor,
    this.selectedTextColor
  });

  @override
  _CircularDaySelectorState createState() => _CircularDaySelectorState();
}


class _CircularDaySelectorState extends State<CircularDaySelector> {

  @override
  void initState() {

    if(this.widget.canBeNotCircle == null){
      this.widget.canBeNotCircle = false;
    }
    if(this.widget.isMonthly == null){
      this.widget.isMonthly = false;
    }

    if(this.widget.color == null){
      this.widget.color = Colors.white;
    }
    if(this.widget.selectedColor == null){
      this.widget.selectedColor = Colors.blue;
    }

    if(this.widget.textColor == null){
      this.widget.textColor = Colors.black;
    }
    if(this.widget.selectedTextColor == null){
      this.widget.selectedTextColor = Colors.white;
    }

    if(this.widget.fontSize == null){
      this.widget.fontSize = 16;
    }

    super.initState();
  }

  @override
  Widget build(BuildContext context) {

    double size = (MediaQuery.of(context).size.width - 64 - (5 * 10)) / 5;
    if(this.widget.isMonthly){
      size = (MediaQuery.of(context).size.width - 64 - (7 * 10)) / 7;
    }

    Widget child = Container(
      width: (!this.widget.canBeNotCircle) ? size : 100,
      height: size,
      decoration: BoxDecoration(
        color: (this.widget.isChecked) ? this.widget.selectedColor : this.widget.color,
        borderRadius: BorderRadius.all(Radius.circular(50)),
      ),
      child: Center(child: Text(this.widget.dayName, style: TextStyle(color: (this.widget.isChecked) ? this.widget.selectedTextColor : this.widget.textColor, fontWeight: FontWeight.w400, fontSize: this.widget.fontSize))),
    );

    if(!this.widget.canBeNotCircle){
      return Container(child: IconButton(
          padding: const EdgeInsets.all(0),
          iconSize: size,
          icon: child,
          onPressed: (){setState(() {
            if(this.widget.isChecked){
              this.widget.isChecked = false;
            }
            else{
              this.widget.isChecked = true;
            }
          });}
      ));
    }else{
      return Container(child: FlatButton(
          padding: const EdgeInsets.all(0),
          child: child,
          onPressed: (){setState(() {
            if(this.widget.isChecked){
              this.widget.isChecked = false;
            }
            else{
              this.widget.isChecked = true;
            }
          });}
      ), margin: const EdgeInsets.only(left: 5));
    }

  }
}
